var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _AppCheckToken_native, _AppCheck_native, _AppCheck_app;
import { firebase, FirebaseApp, FirebaseError } from '@nativescript/firebase-core';
import { Utils } from '@nativescript/core';
import lazy from '@nativescript/core/utils/lazy';
let defaultAppCheck;
const fb = firebase();
Object.defineProperty(fb, 'appCheck', {
    value: (app) => {
        if (!app) {
            if (!defaultAppCheck) {
                defaultAppCheck = new AppCheck();
            }
            return defaultAppCheck;
        }
        return new AppCheck(app);
    },
    writable: false,
});
const NSAppCheck = lazy(() => org.nativescript.firebase.app_check.FirebaseAppCheck);
export class AppCheckToken {
    constructor() {
        _AppCheckToken_native.set(this, void 0);
    }
    static fromNative(token) {
        if (token instanceof com.google.firebase.appcheck.AppCheckToken) {
            const t = new AppCheckToken();
            __classPrivateFieldSet(t, _AppCheckToken_native, token, "f");
            return t;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _AppCheckToken_native, "f");
    }
    get android() {
        return this.native;
    }
    get token() {
        var _a, _b;
        return (_b = (_a = this.native) === null || _a === void 0 ? void 0 : _a.getToken) === null || _b === void 0 ? void 0 : _b.call(_a);
    }
    get expireTimeMillis() {
        var _a, _b;
        return (_b = (_a = this.native) === null || _a === void 0 ? void 0 : _a.getExpireTimeMillis) === null || _b === void 0 ? void 0 : _b.call(_a);
    }
}
_AppCheckToken_native = new WeakMap();
export class AppCheck {
    constructor(app) {
        _AppCheck_native.set(this, void 0);
        _AppCheck_app.set(this, void 0);
        if (app === null || app === void 0 ? void 0 : app.native) {
            __classPrivateFieldSet(this, _AppCheck_native, com.google.firebase.appcheck.FirebaseAppCheck.getInstance(app.native), "f");
        }
        else {
            if (defaultAppCheck) {
                return defaultAppCheck;
            }
            defaultAppCheck = this;
            __classPrivateFieldSet(this, _AppCheck_native, com.google.firebase.appcheck.FirebaseAppCheck.getInstance(), "f");
        }
    }
    activate(isTokenAutoRefreshEnabled) {
        try {
            const firebaseAppCheck = this.native;
            firebaseAppCheck.setTokenAutoRefreshEnabled(isTokenAutoRefreshEnabled);
            let isDebuggable = false;
            const pm = Utils.android.getApplicationContext().getPackageManager();
            if (pm != null) {
                isDebuggable = 0 != (pm.getApplicationInfo(Utils.android.getApplicationContext().getPackageName(), 0).flags & android.content.pm.ApplicationInfo.FLAG_DEBUGGABLE);
            }
            if (isDebuggable) {
                firebaseAppCheck.installAppCheckProviderFactory(com.google.firebase.appcheck.debug.DebugAppCheckProviderFactory.getInstance());
            }
            else {
                firebaseAppCheck.installAppCheckProviderFactory(com.google.firebase.appcheck.safetynet.SafetyNetAppCheckProviderFactory.getInstance());
            }
        }
        catch (e) {
            return;
        }
    }
    getToken(forceRefresh) {
        return new Promise((resolve, reject) => {
            NSAppCheck().getToken(this.native, forceRefresh, new org.nativescript.firebase.app_check.FirebaseAppCheck.Callback({
                onSuccess(param0) {
                    resolve(AppCheckToken.fromNative(param0));
                },
                onError(param0) {
                    const err = FirebaseError.fromNative(param0);
                    reject(err);
                },
            }));
        });
    }
    setTokenAutoRefreshEnabled(enabled) {
        this.native.setTokenAutoRefreshEnabled(enabled);
    }
    get native() {
        return __classPrivateFieldGet(this, _AppCheck_native, "f");
    }
    get ios() {
        return this.native;
    }
    get app() {
        if (!__classPrivateFieldGet(this, _AppCheck_app, "f")) {
            // @ts-ignore
            __classPrivateFieldSet(this, _AppCheck_app, FirebaseApp.fromNative(this.native.app), "f");
        }
        return __classPrivateFieldGet(this, _AppCheck_app, "f");
    }
}
_AppCheck_native = new WeakMap(), _AppCheck_app = new WeakMap();
//# sourceMappingURL=index.android.js.map